<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="style.css">
</head>
<body>
    <div class="center"><h1>PROBLEMAS</h1></div>
    <div class="ejercicios">
        <div>
            <h2>EJERCICIO 1: ARRAY METHODS</h2>
            <p>
                Tiene dos arreglos de String, 'clientes' y 'empleados', 
                y deseas combinarlas para crear un arreglo de contactos. 
                ¿Qué método sería el más adecuado para esta tarea?
            </p>
            <ul class="margen">
                <li>Concat</li>
                <li>Join</li>
                <li>Push</li>
                <li>Splice</li>
            </ul>
            <div class="resultado">
                <ul>
                    <li>
                        <h3>Concat</h3>
                        <p>
                            El método concat() se usa para fusionar dos o más arrays. 
                            Este método no cambia los arrays existentes, sino que 
                            devuelve un nuevo array. 
                        </p>
                    </li>

                    <li>
                        <h3>Join</h3>
                        <p>
                            El método join () crea y devuelve una nueva cadena concatenando 
                            todos los elementos en un array, separados por comas o una cadena 
                            de separación especificada. Si la matriz tiene solo un elemento, 
                            ese elemento se devolverá sin usar el separador.
                        </p>
                    </li>
                    <li>
                        <h3>Push</h3>
                        <p>
                            El método push () agrega uno o más elementos al final 
                            de un array y devuelve la nueva longitud del array.
                        </p>
                    </li>
                    <li>
                        <h3>Splice</h3>
                        <p>
                            El método splice () cambia el contenido de un array al 
                            eliminar o reemplazar elementos existentes y/o agregar 
                            nuevos elementos en su lugar.
                        </p>
                    </li>
                </ul>
                <hr>
                <p class="red">
                    La mejor opcion para este ejercicio es utilizar el metodo <strong> Concat(). </strong> 
                    Puesto que devuelve el nuevo array 'contactos' con los elementos pertenecientes 
                    a 'clientes' y 'empleados'.
                </p>
            </div>
        </div>
        <div>
            <h2>EJERCICIO 2: FILTER</h2>
            <p>
                Teniendo el siguiente array: <strong><i>var numbers = [5,32,43,4]; </i> </strong>
                Y la siguiente función: <strong><i>numbers.filter(function(n) { return n%2 !==0 })</i></strong> 
            </p>
            <p>Agrega una variable para alojar el resultado de la función filter() y explica cual es el resultado.</p>
            <div class="resultado">
                <p>
                    El método <strong>filter()</strong> crea un nuevo array con todos los elementos 
                    que pasan la prueba implementada por la función proporcionada.
                </p>
                <hr>
                <p class="red">La función regresa los números que son impares en el arreglo: <strong id="ejercicio2"></strong></p>
            </div>
        </div>
        <div>
            <h2>EJERCICIO 3: FILTER</h2>
            <p>Dado el siguiente arreglo de objetos: </p>
            <img src="images/img1.png" alt="object">
            <p>Genera la función en javascript que filtre a las personas menores de 35 años.</p>
            <div class="resultado">
                <p>
                    Dado que el método <strong>filter()</strong> pasa por todos los elementos del array, 
                    los elementos que itera pueden ser de cualquier tipo de dato en javascript. 
                    La función implementada sería: <strong>objectArray.filter(function(obj) { return obj.age &lt 35 })</strong>
                </p>
                <hr>
                <p class="red">El nombre de las personas menores de 35 son: <strong id="ejercicio3"></strong></p>
            </div>
        </div>
        <div>
            <h2>EJERCICIO 4: BUCLE FOR</h2>
            <p>Dado el siguiente arreglo de objetos: </p>
            <img src="images/img2.png" alt="">
            <p>Genera la función para obtener el numero de veces que aparece cada nombre.</p>
            <div class="resultado">
                <p>
                    El método <strong>forEach()</strong> ejecuta una función 
                    proporcionada una vez para cada elemento de la matriz.
                </p>
                <hr>
                <p class="red">El número de veces de cada nombre que aparecen en el array son: <strong id="ejercicio4"></strong></p>
            </div>
        </div>
        <div>
            <h2>Ejercicio 5: FOREACH</h2>
            <p>Dado el siguiente arreglo: <strong><i>var myArray = [1,2,3,4];. </i></strong></p>
            <p>Genera la función para imprimir en consola el número maximo y el número mínimo.</p>
            <div class="resultado">
                <p class="red">El numero mayor y menor respectivamente son: <strong id="ejercicio5"></strong></p>
            </div>
        </div>

        <div>
            <h2>EJERCICIO 6: ORDENAMIENTO</h2>
            <p>Teniendo el siguiente objeto: </p>
            <img src="images/img3.png" alt="">
            <p>Genera la función para pasar cada elemento 'key' a un arreglo y ordenarlos según su valor.</p>
            <div class="resultado">
                <p class="red">El arreglo ordenado es: <strong id="ejercicio6"></strong></p>
            </div>
        </div>

    </div>

    <script src="JS.js"></script>
</body>
</html>